/*
 * mcu_system.h
 *
 *  Created on: 21 мар. 2019 г.
 *      Author: Lityagin Aleksandr
 *              alexrayne <alexraynepe196@gmail.com>
  ------------------------------------------------------------------------
    Copyright (c) alexrayne

   All rights reserved.
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
   - Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   - Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
   - Neither the name of ARM nor the names of its contributors may be used
     to endorse or promote products derived from this software without
     specific prior written permission.
   *
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDERS AND CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE. *
 */

#ifndef HAL_ARM_ARM_SYSTEM_H_
#define HAL_ARM_ARM_SYSTEM_H_


#include <c_compat.h>



#ifdef __cplusplus
 extern "C" {
#endif /* __cplusplus */

// эта функция ожидает засыпание до ближайшего события.
//Так как используем ОС - передоверяю это ожидание ядру

INLINE
void wait_fast(){
    __WFE();
    /*
    //Enter LPM3, enable interrupts
    __bis_SR_register(LPM0_bits + GIE);
    //For debugger
    __no_operation();
     */
}


void sys_mcu_reset ( void );
void clock_delay_usec(unsigned len);
void clock_delay_systick(unsigned len);

INLINE
void clock_delay_nsec(unsigned ns){
    unsigned ticks = ((FCPU/1000000)*ns)/1000;
    ticks /= 4; // 1 cycle ticks estimation
    for ( volatile unsigned i = ++ticks ; i > 0; --i)
        __NOP();
}

INLINE
unsigned long clock_systick(){
    return SysTick->VAL;
}


#ifdef __cplusplus
 }
#endif /* __cplusplus */


#endif /* HAL_ARM_ARM_SYSTEM_H_ */
