/*
 * os_isr.hpp
 *
 *  Created on: 10 . 2017 .
 *      Author: alexrayne <alexraynepe196@gmail.com>
  ------------------------------------------------------------------------
    Copyright (c) alexrayne

   All rights reserved.
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
   - Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   - Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
   - Neither the name of ARM nor the names of its contributors may be used
     to endorse or promote products derived from this software without
     specific prior written permission.
   *
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDERS AND CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE. *
 */

#ifndef APP_OS_ISR_H_
#define APP_OS_ISR_H_

#include <c_compat.h>



#ifdef __cplusplus
extern "C" {
#endif /* !__cplusplus */

#include <FreeRTOS.h>
#include <task.h>



#define IRQPRIO_MOST  configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY
#define IRQPRIO_MAX   ((1<<configPRIO_BITS)-1)
#define IRQPRIO_LEAST (configLIBRARY_LOWEST_INTERRUPT_PRIORITY -IRQPRIO_MOST)
#define IRQPRIO(x)    ( ((IRQPRIO_MOST+x) < IRQPRIO_MAX)? (IRQPRIO_MOST+x) : IRQPRIO_MAX )
#define IRQ_OSPRIO(prio) IRQPRIO(prio)



typedef int32_t isr_save_t;

INLINE
isr_save_t gie_disable(){
    return taskENTER_CRITICAL_FROM_ISR();
}

INLINE
void gie_restore(isr_save_t x){
    taskEXIT_CRITICAL_FROM_ISR(x);
}



#ifdef __cplusplus
}
#endif /* !__cplusplus */

#endif /* APP_SRF06_CC26XX_OS_ISR_H_ */
